## kwave 0.8.11

=== doc/CMakeLists.txt ===
#############################################################################
##    Kwave                - doc/CMakeLists.txt
##                           -------------------
##    begin                : Sat May 12 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

FIND_PACKAGE(RequiredProgram REQUIRED)

SET(_help_en_docbook ${CMAKE_CURRENT_SOURCE_DIR}/help_en.docbook)
SET(_help_en_shifted ${CMAKE_CURRENT_BINARY_DIR}/help_en-shifted.docbook)
SET(_help_en_pot ${CMAKE_CURRENT_BINARY_DIR}/help_en.pot)
SET(_version ${PROJECT_SOURCE_DIR}/VERSION)

FIND_REQUIRED_PROGRAM(CP_EXECUTABLE cp)
FIND_REQUIRED_PROGRAM(RM_EXECUTABLE rm)
FIND_REQUIRED_PROGRAM(CAT_EXECUTABLE cat)
FIND_REQUIRED_PROGRAM(SED_EXECUTABLE sed)
FIND_REQUIRED_PROGRAM(XML2POT_EXECUTABLE xml2pot)
FIND_REQUIRED_PROGRAM(MSGMERGE_EXECUTABLE msgmerge)
FIND_REQUIRED_PROGRAM(PO2XML_EXECUTABLE po2xml)
FIND_REQUIRED_PROGRAM(CHECKXML_EXECUTABLE checkXML)

#############################################################################
### how to convert from svg to png                                        ###

FIND_PROGRAM(RSVG_EXECUTABLE NAMES rsvg-convert rsvg)
IF (RSVG_EXECUTABLE)
    GET_FILENAME_COMPONENT(_basename ${RSVG_EXECUTABLE} NAME_WE)
    MESSAGE(STATUS "Found ${_basename}: ${RSVG_EXECUTABLE}")
ENDIF (RSVG_EXECUTABLE)

SET(_test_icon "${CMAKE_SOURCE_DIR}/kwave/toolbar/kwave_zoom_in.svgz")
GET_FILENAME_COMPONENT(_svgz_file ${_test_icon} NAME)
STRING(REPLACE ".svgz" ".png" _png_file ${_svgz_file})

SET(RSVG_AVAILABLE NO)
IF (RSVG_EXECUTABLE)
    # try to convert one icon, to see if "rsvg" really works
    EXECUTE_PROCESS(
	COMMAND ${RSVG_EXECUTABLE} -w 32 -h 32 -f png ${_test_icon} -o "${_png_file}"
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	RESULT_VARIABLE RSVG_CONVERT_RESULT
	OUTPUT_VARIABLE _stdout
	ERROR_VARIABLE _stderr
    )
    IF (${RSVG_CONVERT_RESULT} EQUAL 0)
	MESSAGE(STATUS "Converting svg to png with ${RSVG_EXECUTABLE}")
	MACRO(SVG2PNG _infile _outfile _name)
	    ADD_CUSTOM_COMMAND(OUTPUT ${_outfile}
		COMMAND ${RSVG_EXECUTABLE} -w 32 -h 32 -f png ${_infile} -o ${_outfile}
		DEPENDS ${_infile}
		COMMENT STATUS "Converting ${_name}"
	    )
	ENDMACRO(SVG2PNG)

	SET(RSVG_AVAILABLE YES)
    ELSE (${RSVG_CONVERT_RESULT} EQUAL 0)
	MESSAGE(STATUS "Found rsvg but conversion failed, falling back to convert from ImageMagick")
    ENDIF (${RSVG_CONVERT_RESULT} EQUAL 0)
ENDIF (RSVG_EXECUTABLE)

IF (NOT RSVG_AVAILABLE)
    SET(CONVERT_AVAILABLE NO)
    FIND_PROGRAM(CONVERT_EXECUTABLE NAMES convert)
    IF (CONVERT_EXECUTABLE)
	GET_FILENAME_COMPONENT(_basename ${CONVERT_EXECUTABLE} NAME_WE)
	MESSAGE(STATUS "Found ${_basename}: ${CONVERT_EXECUTABLE}")

	# try to convert one icon, to see if "convert" has proper svg support
	EXECUTE_PROCESS(
	    COMMAND ${CONVERT_EXECUTABLE} -resize 32x32 ${_test_icon} "${_png_file}"
	    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	    RESULT_VARIABLE SVG_CONVERT_RESULT
	    OUTPUT_VARIABLE _stdout
	    ERROR_VARIABLE _stderr
	)
	IF (${SVG_CONVERT_RESULT} EQUAL 0)
	    MESSAGE(STATUS "Converting svg to png with ${CONVERT_EXECUTABLE}")
	    MACRO(SVG2PNG _infile _outfile _name)
		ADD_CUSTOM_COMMAND(OUTPUT ${_outfile}
		    COMMAND ${CONVERT_EXECUTABLE} -resize 32x32 ${_infile} ${_outfile}
		    DEPENDS ${_infile}
		    COMMENT STATUS "Converting ${_name}"
		)
	    ENDMACRO(SVG2PNG)
	    SET(CONVERT_AVAILABLE YES)
	ENDIF (${SVG_CONVERT_RESULT} EQUAL 0)
    ENDIF (CONVERT_EXECUTABLE)

    IF (NOT CONVERT_AVAILABLE)
        MESSAGE(FATAL_ERROR "
        your system lacks support for converting icons in svg format to png.

        You have three options:
        1) install the tool \"rsvg\"
        2) install a version of \"convert\" (ImageMagick) that has proper svg support
        3) omit building the online documentation by using the cmake option \"-DWITH_DOC=OFF\"
        ")
    ENDIF (NOT CONVERT_AVAILABLE)
ENDIF (NOT RSVG_AVAILABLE)

# clean up the temporary png file after conversion test
FILE(REMOVE "${CMAKE_BINARY_DIR}/${_png_file}")

#############################################################################
### help_en.docbook -> help_en.pot                                        ###

ADD_CUSTOM_COMMAND(OUTPUT ${_help_en_pot}
    COMMAND ${XML2POT_EXECUTABLE} ${_help_en_docbook} > ${_help_en_pot}
    DEPENDS ${_help_en_docbook}
)

#############################################################################
### help_en.docbook -> help_en-shifted.docbook                            ###

ADD_CUSTOM_COMMAND(OUTPUT ${_help_en_shifted}
    COMMAND ${CAT_EXECUTABLE} ${_help_en_docbook} |
            ${SED_EXECUTABLE} s/^[[:blank:]]*// >
            ${_help_en_shifted}
    DEPENDS ${_help_en_docbook}
)

#############################################################################
### target for cleaning generated HTML help                               ###

ADD_CUSTOM_TARGET(html_clean
    COMMAND ${RM_EXECUTABLE} -R -f ${CMAKE_CURRENT_BINARY_DIR}/html
)


#############################################################################
### png files with the toolbar icons                                      ###

FILE(GLOB _toolbar_icons "${CMAKE_SOURCE_DIR}/kwave/toolbar/*.svgz")
FOREACH(_toolbar_icon ${_toolbar_icons})
    GET_FILENAME_COMPONENT(_svgz_file ${_toolbar_icon} NAME)
    STRING(REPLACE ".svgz" ".png" _png_file ${_svgz_file})
    SET(_toolbar_png ${CMAKE_CURRENT_BINARY_DIR}/toolbar_${_png_file})
    SVG2PNG(${_toolbar_icon} ${_toolbar_png} ${_png_file})
    SET(_toolbar_pngs "${_toolbar_pngs}" "${_toolbar_png}")
ENDFOREACH(_toolbar_icon ${_toolbar_icons})


#############################################################################
### macro for generating the help for each language                       ###

MACRO(KWAVE_TRANSLATE_DOC _sources _html_sources)

    FILE(GLOB _en_images "${CMAKE_CURRENT_SOURCE_DIR}/en/*.png")

    FOREACH (_lang_and_name ${ARGN})
        STRING(REGEX MATCH "^[^:]+" _lang ${_lang_and_name})
        STRING(REGEX MATCH "[^:]+$$" _lang_name ${_lang_and_name})

        SET(_po ${CMAKE_CURRENT_BINARY_DIR}/help_${_lang}-tmp.po)
        SET(_po_orig ${CMAKE_CURRENT_SOURCE_DIR}/help_${_lang}.po)
        SET(_html_dir ${CMAKE_CURRENT_BINARY_DIR}/html/${_lang})
        SET(_html ${_html_dir}/index.html)
        SET(_common_dir ${KDE4_HTML_INSTALL_DIR}/${_lang}/common)

        # translation of the po and the docbook file not for english
        IF (NOT "${_lang}" STREQUAL "en")
            SET(_docbook ${CMAKE_CURRENT_BINARY_DIR}/help_${_lang}.docbook)
            GET_FILENAME_COMPONENT(_docbook_basename ${_docbook} NAME)

            # translated po file
            ADD_CUSTOM_COMMAND(OUTPUT ${_po}
                COMMAND ${MSGMERGE_EXECUTABLE}
                    -o ${_po} ${_po_orig} ${_help_en_pot}
                COMMAND ${CMAKE_COMMAND} -E copy ${_po} ${_po_orig}
                DEPENDS ${_help_en_pot}
            )

            # translated docbook file
            ADD_CUSTOM_COMMAND(OUTPUT ${_docbook}
                COMMAND ${PO2XML_EXECUTABLE} ${_help_en_shifted} ${_po} |
                    ${SED_EXECUTABLE}
                    s/^\\<\\!ENTITY\\ %\\ English\\ /\\<\\!ENTITY\\ %\\ ${_lang_name}\\ /g
                    > ${_docbook}
                COMMAND ${CHECKXML_EXECUTABLE} ${_docbook}
                DEPENDS ${_po}
                DEPENDS ${_help_en_shifted}
                COMMENT STATUS "Building ${_docbook_basename} (${_lang_name})"
            )

            # copy all images that do not exist in this language
            # from the english version
            FOREACH ( _image_file ${_en_images})
                GET_FILENAME_COMPONENT(_image ${_image_file} NAME)
                SET(_src_img ${CMAKE_CURRENT_SOURCE_DIR}/${_lang}/${_image})
                IF (NOT EXISTS ${_src_img})
                    SET(_missing_png_files_${_lang}
                        "${_missing_png_files_${_lang}}"
                        "${_image_file}"
                    )
                ENDIF (NOT EXISTS ${_src_img})
            ENDFOREACH (_image_file)

        ELSE (NOT "${_lang}" STREQUAL "en")
            SET(_docbook ${_help_en_docbook})
            GET_FILENAME_COMPONENT(_docbook_basename ${_docbook} NAME)
        ENDIF (NOT "${_lang}" STREQUAL "en")

        # generated search index index_<lang>.cache.bz2
        SET(_index "${CMAKE_CURRENT_BINARY_DIR}/index_${_lang}.cache.bz2")
        ADD_CUSTOM_COMMAND(OUTPUT ${_index}
            COMMAND ${KDE4_MEINPROC_EXECUTABLE}
                    --check --cache ${_index} ${_docbook}
            DEPENDS ${_docbook}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )

        # special handling for the GPL license file
        SET(_gpl_translated "${KDE4_HTML_INSTALL_DIR}/${_lang}/common/gpl-translated.html")
        SET(_gpl_english    "${KDE4_HTML_INSTALL_DIR}/en/common/gpl-license.html")
        IF ("${_lang}" STREQUAL "en")
            SET(_gpl ${_gpl_english})
        ELSE ("${_lang}" STREQUAL "en")
            IF (EXISTS ${_gpl_translated})
                SET(_gpl ${_gpl_translated})
            ELSE (EXISTS ${_gpl_translated})
                SET(_gpl ${_gpl_english})
            ENDIF (EXISTS ${_gpl_translated})
        ENDIF ("${_lang}" STREQUAL "en")

        ADD_CUSTOM_COMMAND(OUTPUT ${_html_dir}/gpl-translated.html
            COMMAND mkdir -p ${_html_dir}
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                ${_gpl} ${_html_dir}/gpl-translated.html
        )
        SET(${_html_sources} ${${_html_sources}} ${_html_dir}/gpl-translated.html)

        # generated HTML help
        ADD_CUSTOM_COMMAND(OUTPUT ${_html}
            COMMAND mkdir -p ${_html_dir}
            COMMAND cd ${_html_dir} &&
                    ${KDE4_MEINPROC_EXECUTABLE} --check ${_docbook}
            COMMAND ${RM_EXECUTABLE} -Rf ${_html_dir}/common
            COMMAND mkdir -p ${_html_dir}/common
            COMMAND ${CP_EXECUTABLE}
                ${_toolbar_pngs} ${_html_dir}
            COMMAND ${CP_EXECUTABLE}
                ${CMAKE_CURRENT_SOURCE_DIR}/en/*.png ${_html_dir}
            COMMAND ${CP_EXECUTABLE}
                ${CMAKE_CURRENT_SOURCE_DIR}/${_lang}/*.png ${_html_dir}
            COMMAND ${CMAKE_COMMAND} -E copy_directory
                ${KDE4_HTML_INSTALL_DIR}/en/common ${_html_dir}/common/
            COMMAND ${CMAKE_COMMAND} -E copy_directory
                ${_common_dir} ${_html_dir}/common/
            COMMAND cd ${_html_dir} && ${CMAKE_CURRENT_SOURCE_DIR}/fix-common
            DEPENDS ${_docbook}
            DEPENDS ${_html_dir}/gpl-translated.html
            DEPENDS ${_toolbar_pngs}
            COMMENT STATUS "Generating HTML help for ${_lang} (${_lang_name})"
        )

        SET(${_html_sources} ${${_html_sources}} ${_html})
        SET(${_sources} ${${_sources}} ${_docbook} ${_index})

        # installation of the docbook file
        INSTALL(
            FILES ${_docbook}
            DESTINATION ${KDE4_HTML_INSTALL_DIR}/${_lang}/kwave
            RENAME index.docbook
        )
        SET(_docbook_all ${_docbook_all} ${_docbook})

        # installation of the index.cache.bz2 file
        INSTALL(
            FILES ${_index}
            DESTINATION ${KDE4_HTML_INSTALL_DIR}/${_lang}/kwave

=== kwave/CMakeLists.txt ===
#############################################################################
##    Kwave                - kwave/CMakeLists.txt
##                           -------------------
##    begin                : Wed May 09 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

#############################################################################
### generate menus_config_i18n.cpp                                        ###

# check for programs needed by the script
FIND_REQUIRED_PROGRAM(AWK_EXECUTABLE gawk awk)
FIND_REQUIRED_PROGRAM(CAT_EXECUTABLE cat)
FIND_REQUIRED_PROGRAM(DATE_EXECUTABLE date)
FIND_REQUIRED_PROGRAM(SED_EXECUTABLE sed)
FIND_REQUIRED_PROGRAM(SORT_EXECUTABLE sort)
FIND_REQUIRED_PROGRAM(UNIQ_EXECUTABLE uniq)

SET(MENUSCONFIG2CPP ${CMAKE_BINARY_DIR}/kwave/menusconfig2cpp.sh)

CONFIGURE_FILE(
    ${CMAKE_SOURCE_DIR}/bin/menusconfig2cpp.sh.in
    ${MENUSCONFIG2CPP}
)

ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/menus_config_i18n.cpp
    COMMAND ${MENUSCONFIG2CPP}
        ${CMAKE_CURRENT_SOURCE_DIR}/menus.config
        ${CMAKE_CURRENT_BINARY_DIR}/menus_config_i18n.cpp
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/menus.config
    DEPENDS ${MENUSCONFIG2CPP}
)

#############################################################################

SET(kwave_SRCS
    ApplicationContext.cpp
    App.cpp
    main.cpp
    MainWidget.cpp
    PlayerToolBar.cpp
    ShortcutWrapper.cpp
    Splash.cpp
    TopWidget.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/menus_config_i18n.cpp
)

#############################################################################
### some pixmaps to be installed in the data dir                          ###

SET(kwave_PIXMAPS
    pics/amplify_free.png
    pics/fade_in.png
    pics/fade_out.png
    pics/knob.xpm
    pics/kwave-splash.png
    pics/light_off.xpm
    pics/light_on.xpm
    pics/logo.xpm
    pics/noise.png
    pics/selectedknob.xpm
    pics/sound_device.png
    pics/sound_subdevice.png
    pics/sound_card.png
    pics/sound_note.png
)

#############################################################################
### scalable action icons to be installed in the icon dir                 ###

SET(kwave_ACTION_ICONS
    toolbar/kwave_player_end.svgz
    toolbar/kwave_player_fwd.svgz
    toolbar/kwave_player_pause.svgz
    toolbar/kwave_player_pause_2.svgz
    toolbar/kwave_player_play.svgz
    toolbar/kwave_player_loop.svgz
    toolbar/kwave_player_record.svgz
    toolbar/kwave_player_rew.svgz
    toolbar/kwave_player_start.svgz
    toolbar/kwave_player_stop.svgz
    toolbar/kwave_viewmagfit.svgz
    toolbar/kwave_viewmag.svgz
    toolbar/kwave_zoom_in.svgz
    toolbar/kwave_zoom_original.svgz
    toolbar/kwave_zoom_out.svgz
)

#############################################################################

QT4_AUTOMOC( ${kwave_SRCS} )
KDE4_ADD_EXECUTABLE(kwave_core ${kwave_SRCS})

#############################################################################

TARGET_LINK_LIBRARIES(kwave_core
    kwavegui
    kwave
    audiofile
    ${SAMPLERATE_LIBS}
    ${QT_AND_KDECORE_LIBS}
)

ADD_DEPENDENCIES(kwave_core libkwavegui libkwave)

SET_TARGET_PROPERTIES(kwave_core PROPERTIES OUTPUT_NAME "kwave")

#############################################################################
### install files                                                         ###

# the main program
INSTALL(TARGETS kwave_core     DESTINATION ${DESTDIR}${KDE4_BIN_INSTALL_DIR})

# other files
INSTALL(FILES menus.config     DESTINATION ${DESTDIR}${KDE4_DATA_INSTALL_DIR}/kwave)
INSTALL(FILES ${kwave_PIXMAPS} DESTINATION ${DESTDIR}${KDE4_DATA_INSTALL_DIR}/kwave/pics)
INSTALL(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/kwave.desktop
    DESTINATION ${KDE4_XDG_APPS_INSTALL_DIR}
)

# action icons
INSTALL(
    FILES ${kwave_ACTION_ICONS}
    DESTINATION ${DESTDIR}${KDE4_ICON_INSTALL_DIR}/hicolor/scalable/actions
)

# application icon
INSTALL(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/pics/kwave.svgz
    DESTINATION ${DESTDIR}${KDE4_ICON_INSTALL_DIR}/hicolor/scalable/apps
)

#############################################################################
#############################################################################

=== plugins/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

MACRO(KWAVE_PLUGIN _plugin)

    #########################################################################
    ### compile stage                                                     ###

    INCLUDE_DIRECTORIES(
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
        ${QT_INCLUDE_DIR}
    )
    KDE4_ADD_UI_FILES(plugin_${_plugin}_LIB_SRCS ${plugin_${_plugin}_LIB_UI})
    QT4_AUTOMOC(${plugin_${_plugin}_LIB_SRCS})

    #########################################################################
    ### link stage                                                        ###

    KDE4_ADD_LIBRARY(plugin_${_plugin} SHARED ${plugin_${_plugin}_LIB_SRCS})
    TARGET_LINK_LIBRARIES(plugin_${_plugin}
        kwavegui
        kwave
        ${plugin_${_plugin}_LIBS}
        ${SAMPLERATE_LIBS}
        ${QT_AND_KDECORE_LIBS}
    )

    SET_TARGET_PROPERTIES(plugin_${_plugin} PROPERTIES PREFIX "")
    SET_TARGET_PROPERTIES(plugin_${_plugin} PROPERTIES SUFFIX "")
    SET_TARGET_PROPERTIES(plugin_${_plugin} PROPERTIES OUTPUT_NAME "${_plugin}")
    SET_TARGET_PROPERTIES(plugin_${_plugin} PROPERTIES LINK_FLAGS
        "-Wl,--export-dynamic")
    SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

    #########################################################################
    ### install                                                           ###

    ADD_DEPENDENCIES(plugin_${_plugin} libkwave libkwavegui)

    EXECUTE_PROCESS(COMMAND "${KDE4_KDECONFIG_EXECUTABLE}"
        --expandvars --install module
        OUTPUT_VARIABLE KDE4_MODULE_INSTALL_DIR
        OUTPUT_STRIP_TRAILING_WHITESPACE)

    INSTALL(TARGETS
        plugin_${_plugin}
        LIBRARY
        DESTINATION ${DESTDIR}${KDE4_MODULE_INSTALL_DIR}/plugins/kwave
    )

ENDMACRO(KWAVE_PLUGIN)

#############################################################################

ADD_SUBDIRECTORY( about )
ADD_SUBDIRECTORY( amplifyfree )
ADD_SUBDIRECTORY( band_pass )
ADD_SUBDIRECTORY( codec_ascii )
ADD_SUBDIRECTORY( codec_audiofile ) # needs libaudiofile
ADD_SUBDIRECTORY( codec_flac )      # needs libflac 1.1.1 or 1.1.2
ADD_SUBDIRECTORY( codec_mp3 )       # needs libmad + id3lib + "lame"
ADD_SUBDIRECTORY( codec_ogg )       # needs libogg and (libvorbis or libopus)
ADD_SUBDIRECTORY( codec_wav )       # needs libaudiofile
ADD_SUBDIRECTORY( debug )
ADD_SUBDIRECTORY( fileinfo )
ADD_SUBDIRECTORY( goto )
ADD_SUBDIRECTORY( lowpass )
ADD_SUBDIRECTORY( memory )
ADD_SUBDIRECTORY( newsignal )
ADD_SUBDIRECTORY( noise )
ADD_SUBDIRECTORY( normalize )
ADD_SUBDIRECTORY( notch_filter )
ADD_SUBDIRECTORY( pitch_shift )
ADD_SUBDIRECTORY( playback )        # needs OSS and/or ALSA
ADD_SUBDIRECTORY( record )          # needs OSS and/or ALSA
ADD_SUBDIRECTORY( reverse )
ADD_SUBDIRECTORY( samplerate )      # needs libsamplerate
ADD_SUBDIRECTORY( saveblocks )
ADD_SUBDIRECTORY( selectrange )
ADD_SUBDIRECTORY( sonagram )        # needs fftw >= 3.0
ADD_SUBDIRECTORY( volume )
ADD_SUBDIRECTORY( zero )

#############################################################################
#############################################################################

=== plugins/codec_ascii/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/codec_ascii/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

SET(plugin_codec_ascii_LIB_SRCS
    AsciiCodecPlugin.cpp
    AsciiDecoder.cpp
    AsciiEncoder.cpp
)

KWAVE_PLUGIN(codec_ascii)

#############################################################################
#############################################################################

=== plugins/codec_flac/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/codec_flac/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

OPTION(WITH_FLAC "enable support for FLAC files [default=on]" ON)
IF (WITH_FLAC)

    INCLUDE(CheckLibraryExists)

#############################################################################
### check for FLAC header files                                           ###

    CHECK_INCLUDE_FILES(FLAC/format.h HAVE_FLAC_HEADERS)
    IF (HAVE_FLAC_HEADERS)
        MESSAGE(STATUS "Found FLAC include files")
    ELSE (HAVE_FLAC_HEADERS)
        MESSAGE(FATAL_ERROR "libFLAC not found, please install libflac !")
    ENDIF (HAVE_FLAC_HEADERS)

#############################################################################
### check for FLAC++ header files                                         ###

    IF (HAVE_FLAC_HEADERS)
        CHECK_INCLUDE_FILES(FLAC++/decoder.h HAVE_FLAC_HEADERS)
    ENDIF (HAVE_FLAC_HEADERS)
    IF (HAVE_FLAC_HEADERS)
        CHECK_INCLUDE_FILES(FLAC++/metadata.h HAVE_FLAC_HEADERS)
    ENDIF (HAVE_FLAC_HEADERS)

    IF (HAVE_FLAC_HEADERS)
        MESSAGE(STATUS "Found FLAC++ include files")
    ELSE (HAVE_FLAC_HEADERS)
        MESSAGE(FATAL_ERROR "libFLAC++ not found, please install libflac++ !")
    ENDIF (HAVE_FLAC_HEADERS)

    SET(_try_src_dir "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp")

#############################################################################
### check for FLAC API v1.1.3 and above                                   ###
### known to work:
### - v1.1.3
### - v1.1.4
### - v1.2.0
### - v1.2.1
### (older ones are no longer supported)

    IF (NOT FLAC_API_FOUND)
        SET(_try_flac_1_1_3 "${_try_src_dir}/cmake_try_flac_v1_1_3.cpp")
        WRITE_FILE("${_try_flac_1_1_3}" "
            #include <FLAC/export.h>
            #include <FLAC/format.h>
            #include <FLAC++/decoder.h>
            #include <FLAC++/encoder.h>
            #include <FLAC++/metadata.h>

            /* FLAC-1.1.3 has cur=8, rev=0 */
            /* FLAC-1.1.4 has cur=8, rev=1 */
            #if !defined(FLAC_API_VERSION_CURRENT) || \\
                !defined(FLAC_API_VERSION_REVISION)
                #error \"FLAC\ API\ is\ much\ too\ old\"
            #endif

            #if (FLAC_API_VERSION_CURRENT < 8)
                #error \"FLAC\ API\ is\ too\ old\"
            #endif

            int main(int, char **)
            {
                FLAC__StreamEncoderInitStatus init_state_d =
                        FLAC__STREAM_ENCODER_INIT_STATUS_OK;
                FLAC__StreamDecoderInitStatus init_state_e =
                        FLAC__STREAM_DECODER_INIT_STATUS_OK;
                (void)init_state_d;
                (void)init_state_e;
                return 0;
            }
        ")

        TRY_COMPILE(
            FLAC_API_VERSION_1_1_3
            ${CMAKE_BINARY_DIR}
            ${_try_flac_1_1_3}
            CMAKE_FLAGS -DLINK_LIBRARIES:STRING=FLAC++
            OUTPUT_VARIABLE _out
        )
#         MESSAGE(STATUS ${_out})

        IF (FLAC_API_VERSION_1_1_3)
            MESSAGE(STATUS "Found FLAC API version 1.1.3 or newer")
            SET(FLAC_API_FOUND BOOL ON)
        ELSE (FLAC_API_VERSION_1_1_3)
            # failed, now try again with linking ogg
            WRITE_FILE("${_try_flac_1_1_3}" "
                #include <FLAC/export.h>
                #include <FLAC/format.h>
                #include <FLAC++/decoder.h>
                #include <FLAC++/encoder.h>
                #include <FLAC++/metadata.h>

                /* FLAC-1.1.3 has cur=8, rev=0 */
                /* FLAC-1.1.4 has cur=8, rev=1 */
                #if !defined(FLAC_API_VERSION_CURRENT) || \\
                    !defined(FLAC_API_VERSION_REVISION)
                    #error \"FLAC\ API\ is\ much\ too\ old\"
                #endif

                #if (FLAC_API_VERSION_CURRENT < 8)
                    #error \"FLAC\ API\ is\ too\ old\"
                #endif

                int main(int, char **)
                {
                    FLAC__StreamEncoderInitStatus init_state_d =
                            FLAC__STREAM_ENCODER_INIT_STATUS_OK;
                    FLAC__StreamDecoderInitStatus init_state_e =
                            FLAC__STREAM_DECODER_INIT_STATUS_OK;
                    (void)init_state_d;
                    (void)init_state_e;
                    return 0;
                }
            ")
            TRY_COMPILE(
                FLAC_API_VERSION_1_1_3
                ${CMAKE_BINARY_DIR}
                ${_try_flac_1_1_3}
                CMAKE_FLAGS -DLINK_LIBRARIES:STRING=FLAC++ -DLINK_LIBRARIES:STRING=ogg
                OUTPUT_VARIABLE _out
            )
            IF (FLAC_API_VERSION_1_1_3)
                SET(FLAC_NEEDS_OGG ogg)
                MESSAGE(STATUS "Found FLAC API version 1.1.3 or newer (needs libogg)")
                SET(FLAC_API_FOUND BOOL ON)
            ENDIF (FLAC_API_VERSION_1_1_3)
        ENDIF (FLAC_API_VERSION_1_1_3)

        IF (NOT FLAC_API_VERSION_1_1_3)
#             MESSAGE(STATUS "FLAC API v1.1.3 does not work")
#             MESSAGE(STATUS "${_out}")
        ENDIF (NOT FLAC_API_VERSION_1_1_3)
    ENDIF (NOT FLAC_API_FOUND)

#############################################################################
### abort if no working FLAC API has been found :-(                       ###

    IF (NOT FLAC_API_FOUND)
        MESSAGE(FATAL_ERROR "Found no supported FLAC API")
    ENDIF (NOT FLAC_API_FOUND)

    SET(HAVE_FLAC  ON CACHE BOOL "enable FLAC codec")
    SET(plugin_codec_flac_LIB_SRCS
        FlacCodecPlugin.cpp
        FlacDecoder.cpp
        FlacEncoder.cpp
    )

    SET(plugin_codec_flac_LIBS FLAC++ FLAC ${FLAC_NEEDS_OGG} )

    KWAVE_PLUGIN(codec_flac)

ENDIF(WITH_FLAC)

#############################################################################
#############################################################################

=== plugins/codec_mp3/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/codec_mp3/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

OPTION(WITH_MP3 "enable support for mp3 files [default=off]" OFF)
IF (WITH_MP3)

#############################################################################
### check for id3lib headers and library                                  ###

    INCLUDE(CheckIncludeFileCXX)

    CHECK_INCLUDE_FILE_CXX(id3/globals.h HAVE_ID3_HEADER_GLOBALS_H)
    IF (HAVE_ID3_HEADER_GLOBALS_H)
        CHECK_INCLUDE_FILE_CXX(id3/tag.h HAVE_ID3_HEADER_TAG_H)
    ENDIF (HAVE_ID3_HEADER_GLOBALS_H)
    IF (HAVE_ID3_HEADER_TAG_H)
        CHECK_INCLUDE_FILE_CXX(id3/misc_support.h HAVE_ID3_HEADERS)
    ENDIF (HAVE_ID3_HEADER_TAG_H)

    IF (HAVE_ID3_HEADERS)
        SET(_try_src_dir "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp")
        SET(_try_id3lib "${_try_src_dir}/cmake_try_id3lib.cpp")
        WRITE_FILE("${_try_id3lib}" "
            #include <id3/globals.h>
            #include <id3/readers.h>
            #include <id3/tag.h>
            int main()
            {
                ID3_Tag tag;
                ID3_MemoryReader reader;
                tag.Link(reader);
                return 0;
            }
        ")
        TRY_COMPILE(
            HAVE_ID3_LIB
            ${CMAKE_BINARY_DIR}
            ${_try_id3lib}
            CMAKE_FLAGS -DLINK_LIBRARIES:STRING=id3\;stdc++\;z
            OUTPUT_VARIABLE _out
        )
    ENDIF (HAVE_ID3_HEADERS)

    IF (NOT HAVE_ID3_LIB)
        MESSAGE(FATAL_ERROR "

        id3lib seems not to be installed or too old !

        You can download id3lib from http://id3lib.sourceforge.net/
        and fetch the latest version from there. If you download the
        rpm package, please don't forget to fetch id3lib-devel too,
        it is needed for compiling Kwave!

        Note: at least version 3.8.1 is needed.
        ")
    ENDIF (NOT HAVE_ID3_LIB)

#############################################################################
### check for libmad headers and library                                  ###

    CHECK_INCLUDE_FILES(mad.h HAVE_MAD_H)
    IF (HAVE_MAD_H)
        CHECK_LIBRARY_EXISTS(mad mad_decoder_init "" HAVE_MAD_LIB)
    ENDIF (HAVE_MAD_H)

    IF (NOT HAVE_MAD_LIB)
        MESSAGE(FATAL_ERROR "

        the mad package is missing.
        please install the mad and the mad-devel package!

        ")
    ENDIF (NOT HAVE_MAD_LIB)

#############################################################################

    SET(HAVE_MP3  ON CACHE BOOL "enable MP3 codec")

    SET(plugin_codec_mp3_LIB_SRCS
        ID3_PropertyMap.cpp
        ID3_QIODeviceReader.cpp
        ID3_QIODeviceWriter.cpp
        MP3CodecPlugin.cpp
        MP3Decoder.cpp
        MP3Encoder.cpp
        MP3EncoderDialog.cpp
        MP3EncoderSettings.cpp
    )

    SET(plugin_codec_mp3_LIB_UI
        MP3EncoderDialogBase.ui
    )

    SET(plugin_codec_mp3_LIBS
        mad id3 stdc++ z
    )

    KWAVE_PLUGIN(codec_mp3)

ENDIF (WITH_MP3)

#############################################################################
#############################################################################

=== plugins/debug/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/debug/CMakeLists.txt
##                           -------------------
##    begin                : Mon Feb 02 2009
##    copyright            : (C) 2009 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

IF (DEBUG)
    SET(plugin_debug_LIB_SRCS
	DebugPlugin.cpp
    )

    KWAVE_PLUGIN(debug)
ENDIF (DEBUG)

#############################################################################
#############################################################################

=== plugins/fileinfo/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/fileinfo/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

SET(plugin_fileinfo_LIB_SRCS
    BitrateSpinBox.cpp
    BitrateWidget.cpp
    CompressionWidget.cpp
    FileInfoDialog.cpp
    FileInfoPlugin.cpp
    KeywordWidget.cpp
    SelectDateDialog.cpp
)

SET(plugin_fileinfo_LIB_UI
    BitrateWidgetBase.ui
    CompressionWidgetBase.ui
    FileInfoDlg.ui
    KeywordWidgetBase.ui
    SelectDateDlg.ui
)

KWAVE_PLUGIN(fileinfo)

#############################################################################
#############################################################################

=== plugins/lowpass/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/lowpass/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

SET(plugin_lowpass_LIB_SRCS
    LowPassDialog.cpp
    LowPassFilter.cpp
    LowPassPlugin.cpp
)

SET(plugin_lowpass_LIB_UI
    LowPassDlg.ui
)

KWAVE_PLUGIN(lowpass)

#############################################################################
#############################################################################

=== plugins/newsignal/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/newsignal/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

SET(plugin_newsignal_LIB_SRCS
    NewSignalDialog.cpp
    NewSignalPlugin.cpp
)

SET(plugin_newsignal_LIB_UI
    NewSigDlg.ui
)

KWAVE_PLUGIN(newsignal)

#############################################################################
#############################################################################

=== plugins/pitch_shift/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/pitch_shift/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

SET(plugin_pitch_shift_LIB_SRCS
    PitchShiftDialog.cpp
    PitchShiftFilter.cpp
    PitchShiftPlugin.cpp
)

SET(plugin_pitch_shift_LIB_UI
    PitchShiftDlg.ui
)

KWAVE_PLUGIN(pitch_shift)

#############################################################################
#############################################################################

=== plugins/record/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/record/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

#############################################################################

IF (HAVE_OSS_SUPPORT)
    SET(RECORD_SOURCES ${RECORD_SOURCES} Record-OSS.cpp)
ENDIF (HAVE_OSS_SUPPORT)
IF (HAVE_ALSA_SUPPORT)
    SET(RECORD_SOURCES ${RECORD_SOURCES} Record-ALSA.cpp)
    SET(RECORD_REQUIRED_LIBS ${RECORD_REQUIRED_LIBS} asound)
ENDIF (HAVE_ALSA_SUPPORT)

SET(plugin_record_LIB_SRCS
    LevelMeter.cpp
    RecordController.cpp
    RecordDialog.cpp
    RecordParams.cpp
    RecordPlugin.cpp
    RecordThread.cpp
    RecordTypesMap.cpp
    SampleDecoderLinear.cpp
    StatusWidget.cpp
    ${RECORD_SOURCES}
)

SET(plugin_record_LIB_UI
    RecordDlg.ui
)

IF (RECORD_REQUIRED_LIBS)
    SET(plugin_record_LIBS ${RECORD_REQUIRED_LIBS})
ENDIF (RECORD_REQUIRED_LIBS)

KWAVE_PLUGIN(record)

#############################################################################
#############################################################################

## kwave 0.8.11-1

=== debian/changelog ===
kwave (0.8.11-1-1) unstable; urgency=low

  * New upstream release
  * Fix vcs-field-bitrotted
  * Add spelling-error-in-binary.patch

 -- Mark Purcell <msp@debian.org>  Sun, 08 Dec 2013 09:21:00 +1100

=== debian/control ===
Source: kwave
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>
Build-Depends: debhelper (>= 9), pkg-kde-tools (>= 0.4),
 kdelibs5-dev (>= 4:4.2.0), gettext, pkg-config,
 libsamplerate0-dev, libpulse-dev,
 imagemagick, librsvg2-bin, recode, libid3-3.8.3-dev (>= 3.8.3-4.2),
 libaudiofile-dev (>> 0.3.0), libogg-dev, libvorbis-dev (>= 1.0.0-2), libopus-dev (>= 1.0.0),
 libflac++-dev (>= 1.1.4), libmad0-dev, libgsl0-dev,
 libasound2-dev [linux-any],
 libicu-dev,
 libfftw3-dev,
 poxml, gawk, cmake
Homepage: http://kwave.sourceforge.net
Standards-Version: 3.9.5
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/kwave/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/kwave/trunk

Package: kwave
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sound editor for KDE
 Kwave is a sound editor designed for the KDE Desktop Environment.
 .
 With Kwave you can record, play back, import and edit many sorts of audio
 files including multi-channel files.
 .
 Kwave includes some plugins to transform audio files in several ways and
 presents a graphical view with a complete zoom- and scroll capability.
 .
 Its features include:
  * 24 Bit Support
  * Undo/Redo
  * Use of multicore CPUs (SMP, hyperthreading)
  * Simple Drag & Drop
  * Realtime Pre-Listen for some effects
  * Support for multi-track files
  * Playback and recording via native ALSA (or OSS, deprecated)
  * Playback via PulseAudio and Phonon
  * Load and edit-capability for large files (can use virtual memory)
  * Reading and auto-repair of damaged wav-files
  * Supports multiple windows
  * Extendable Plugin interface
  * a nice splashscreen
  * some label handling

Package: kwave-dbg
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, kwave (= ${binary:Version}) 
Priority: extra
Section: debug
Description: sound editor for KDE - debug symbols
 Kwave is a sound editor designed for the KDE Desktop Environment.
 .
 With Kwave you can record, play back, import and edit many sorts of audio
 files including multi-channel files.
 .
 This package includes the debug symbols.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

ifneq ($(DEB_HOST_ARCH_OS),linux)
  DEB_CMAKE_CUSTOM_FLAGS += -DWITH_ALSA=OFF
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_CUSTOM_FLAGS)

override_dh_strip:
	dh_strip --dbg-package=kwave-dbg
	strip --strip-unneeded --remove-section=.comment debian/kwave/usr/lib/kde4/plugins/kwave/*

override_dh_auto_install:
	dh_auto_install --destdir=debian/kwave
